package com.urbancode.anthill3.plugin.scm

import com.urbancode.anthill3.*
import com.urbancode.anthill3.plugin.scm.changelog.*;

import java.util.Date;
import java.util.TimeZone;
import java.text.SimpleDateFormat


public class SCMQuietPeriod extends SCMChangelog {

    //**************************************************************************
    // CLASS
    //**************************************************************************

    //**************************************************************************
    // INSTANCE
    //**************************************************************************

    /**
     *
     * @return date of the last change
     */
    public def execute() {
        // quiet period needs to init workspace
        initWorkspace();

        def logOutput = runLogCommand()
        List<ChangeSet> changeSets = parseLogIntoChangeSets(logOutput);
        Date latestChangeDate = changeSets.collect{ChangeSet cs -> cs.date}.max();
        return latestChangeDate;
    }

    /**
     * {@inheritDoc}
     * Override to only use the remote branch for QP changelog (local branch will not be updated/exist yet)
     */
    @Override
    protected String getTargetBranch() {
        return "$remoteName/$branch";
    }
}